// CGUIDE.H

#if !defined ( _CGUIDE_H_ )

#define _CGUIDE_H_

#define GUIDE_GUI							0
#define GUIDE_ENGINE						1
#define	GUIDE_CLIENT						0
#define GUIDE_SERVER						1

#define GUIDE_MAX_CHARSTRING				256
#define GUIDE_GUIMESSAGE_READ_QUEUE_SIZE	512
#define GUIDE_MESSAGE_DELIMITER				10
#define GUIDE_MESSAGE_DELIMITER_RANGE		32
#define GUIDE_BUFFER_SIZE					65536
#define GUIDE_DBG_BUFFER_SIZE				64

// GUIDE NOTIFICATION MESSAGES
#define GUIDE_NOTIFICATION_ONACCEPT			-1
#define GUIDE_NOTIFICATION_ONCONNECT		-2
#define GUIDE_NOTIFICATION_ONCLOSE			-3
#define GUIDE_NOTIFICATION_ONDXPGAMEEND		-4
#define GUIDE_NOTIFICATION_ONDXPGAMEACC		-5

// WM_USER Message
#define WM_USER_GUIDE_MESSAGE				0x8000

// Definition Socket Default Port
#define SOCKET_DEFAULT_PORT					27533

// Definition SOCKET Default IP
#define SOCKET_DEFAULT_IP					"127.0.0.1"

// Definition DXP
#define DXP_PORT			27531
#define DXP_IPADDRESS		"127.0.0.1"
#define DXP_VERSION			"01"
#define DXP_NAMELENGTH		32
#define DXP_WHITE			"W"
#define DXP_BLACK			"B"
#define DXP_INITPOSITION	"A"
#define DXP_DXPPOSITION		"B"

class CGuide ;

class CDraughtsSocket : public CAsyncSocket
{

public:

	CDraughtsSocket() ;
	virtual ~CDraughtsSocket() ;

public:
	bool m_bAccept ;
	bool m_bConnect ;
	CGuide*	m_pGuide ;

	void OnAccept(int) ;
	void OnClose(int) ;
	void OnConnect(int) ;
	void OnReceive(int) ;

} ;


class CGuide
{

public:
	
	CGuide() ;
	~CGuide() ;

	int		m_iGUIDE_Mode ;
	int		m_iCommunicationMode ;
	int		m_iNPacketReceive ;

	int		m_iDBG_PacketSize[GUIDE_DBG_BUFFER_SIZE] ;
	CString	m_csDBG_PacketString[GUIDE_DBG_BUFFER_SIZE] ;

	CString	m_csReceiveBuffer ;

	CString	m_csGUIMessage[GUIDE_GUIMESSAGE_READ_QUEUE_SIZE] ;

	bool	Init(int, int, int, CString ) ;
	bool	Close() ;

	bool	Connect(int ) ;

	void	GetMsgString(char* ) ;

	bool	SendMessageToEngine(CString ) ;
	bool	SendMessageToGUI(CString ) ;
	
	bool	OnAccept(void) ;
	bool	OnClose(void) ;
	bool	OnConnect(void) ;
	bool	OnReceive(void) ;

	bool	OnDXPGameAcc(void) ;
	bool	OnDXPGameEnd(void) ;
	
	bool CommandMessage(CString , CString* , CString* ) ;
	bool ParseMessage(CString*, CString* ) ;

	bool			m_bConnect ;
	int				m_Port ;
	int				m_iIndex_GUIMESSAGE_READ ;

	CString			m_IP ;
	
	CWnd*			m_pWnd ;

	CDraughtsSocket	m_ConnectSocket ;
	CDraughtsSocket	m_ListenSocket ;

	CWinThread*	m_pConnectThread ;

	void InitConnectThread(void ) ;
	static UINT ConnectThreadFunc(LPVOID ) ;
	void	runConnect(void ) ;
	
} ;

#endif	// _CGUIDE_H_